/* mk_outvec.c
** setup header for outvec_STDOUT.c
** using sysconf() to check IOV_MAX on build platform
** wcm, 2010.12.01 - 2010.12.06
** ===
*/

#include <stdio.h>
#include <unistd.h>

/* posix requires at least this IOV_MAX: */
#define OUTVEC_STDOUT_MIN  16
/* sufficient for this outvec (any more is overkill): */
#define OUTVEC_STDOUT_MAX  64

const char  progname[] = "mk_outvec";

int
main(int argc, char * argv[])
{
  long  limit = 0;

  (void)argc;
  (void)argv;

#ifdef _SC_IOV_MAX
  limit = sysconf(_SC_IOV_MAX);
#endif

  if(limit <= OUTVEC_STDOUT_MIN)
      limit = OUTVEC_STDOUT_MIN;
  else if(limit > OUTVEC_STDOUT_MAX)
      limit = OUTVEC_STDOUT_MAX;

  printf("/* outvec_STDOUT.h\n"
         "** automatically generated by %s (%s) \n"
         "*/\n\n", progname, __FILE__ );

  printf("#define _VEC_STDOUT_SIZE  %d\n\n", (int)limit);

  printf("/* eof: outvec_STDOUT.h */\n");

  return 0;
} 

/* eof: mk_outvec.c */
